Overview | Package | Class | Tree | Deprecated | Index | Help
| Bouncy Castle Cryptography Library 1.45
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.bouncycastle.crypto.modes
Interface AEADBlockCipher

All Known Implementing Classes:
  CCMBlockCipher, EAXBlockCipher, GCMBlockCipher

    public interface AEADBlockCipher

A block cipher mode that includes authenticated encryption with a streaming mode and optional associated data.

See Also:
  `AEADParameters`

Method Summary
`int` | `doFinal(byte[] out, int outOff)` Finish the operation either appending or verifying the MAC at the end of the data.
`java.lang.String` | `getAlgorithmName()` Return the name of the algorithm.
`byte[]` | `getMac()` Return the value of the MAC associated with the last stream processed.
`int` | `getOutputSize(int len)` return the size of the output buffer required for a processBytes plus a doFinal with an input of len bytes.
`BlockCipher` | `getUnderlyingCipher()` return the cipher this object wraps.
`int` | `getUpdateOutputSize(int len)` return the size of the output buffer required for a processBytes an input of len bytes.
`void` | `init(boolean forEncryption, CipherParameters params)` initialise the underlying cipher.
`int` | `processByte(byte in, byte[] out, int outOff)` encrypt/decrypt a single byte.
`int` | `processBytes(byte[] in, int inOff, int len, byte[] out, int outOff)` process a block of bytes from in putting the result into out.
`void` | `reset()` Reset the cipher.

Method Detail

### init

    void init(boolean forEncryption,
              CipherParameters params)
              throws java.lang.IllegalArgumentException

  initialise the underlying cipher. Parameter can either be an AEADParameters or a ParametersWithIV object.

  Parameters:
    `forEncryption` - true if we are setting up for encryption, false otherwise.
    `params` - the necessary parameters for the underlying cipher to be initialised.
  Throws:
    `java.lang.IllegalArgumentException` - if the params argument is inappropriate.

### getAlgorithmName

    java.lang.String getAlgorithmName()

  Return the name of the algorithm.

  Returns:
    the algorithm name.

### getUnderlyingCipher

    BlockCipher getUnderlyingCipher()

  return the cipher this object wraps.

  Returns:
    the cipher this object wraps.

### processByte

    int processByte(byte in,
                    byte[] out,
                    int outOff)
                    throws DataLengthException

  encrypt/decrypt a single byte.

  Parameters:
    `in` - the byte to be processed.
    `out` - the output buffer the processed byte goes into.
    `outOff` - the offset into the output byte array the processed data starts at.
  Returns:
    the number of bytes written to out.
  Throws:
    `DataLengthException` - if the output buffer is too small.

### processBytes

    int processBytes(byte[] in,
                     int inOff,
                     int len,
                     byte[] out,
                     int outOff)
                     throws DataLengthException

  process a block of bytes from in putting the result into out.

  Parameters:
    `in` - the input byte array.
    `inOff` - the offset into the in array where the data to be processed starts.
    `len` - the number of bytes to be processed.
    `out` - the output buffer the processed bytes go into.
    `outOff` - the offset into the output byte array the processed data starts at.
  Returns:
    the number of bytes written to out.
  Throws:
    `DataLengthException` - if the output buffer is too small.

### doFinal

    int doFinal(byte[] out,
                int outOff)
                throws java.lang.IllegalStateException,
                       InvalidCipherTextException

  Finish the operation either appending or verifying the MAC at the end of the data.

  Parameters:
    `out` - space for any resulting output data.
    `outOff` - offset into out to start copying the data at.
  Returns:
    number of bytes written into out.
  Throws:
    `java.lang.IllegalStateException` - if the cipher is in an inappropriate state.
    `InvalidCipherTextException` - if the MAC fails to match.

### getMac

    byte[] getMac()

  Return the value of the MAC associated with the last stream processed.

  Returns:
    MAC for plaintext data.

### getUpdateOutputSize

    int getUpdateOutputSize(int len)

  return the size of the output buffer required for a processBytes an input of len bytes.

  Parameters:
    `len` - the length of the input.
  Returns:
    the space required to accommodate a call to processBytes with len bytes of input.

### getOutputSize

    int getOutputSize(int len)

  return the size of the output buffer required for a processBytes plus a doFinal with an input of len bytes.

  Parameters:
    `len` - the length of the input.
  Returns:
    the space required to accommodate a call to processBytes and doFinal with len bytes of input.

### reset

    void reset()

  Reset the cipher. After resetting the cipher is in the same state as it was after the last init (if there was one).

Overview | Package | Class | Tree | Deprecated | Index | Help
| Bouncy Castle Cryptography Library 1.45
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD